-- by modelleicher
-- www.schwabenmodding.bplaced.net

TractorAnimations = {};

function TractorAnimations.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function TractorAnimations:load(savegame)
	-- Zapfwellenstummel / Powershaft rotation
	self.stummelIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations#zapfwellenStummelIndex"));

	-- Temperaturzeiger / l Temperatur Anzeige eckig
	self.temperaturZeiger = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger#zeigerIndex"));
	self.temperaturZeigerMaxRot = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger#maxRotation"));
	self.tempCnt = 0;

	-- Temperaturzeiger2 / Wasser Temperatur Anzeige eckig
	self.temperaturZeiger2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger2#zeigerIndex"));
	self.temperaturZeigerMaxRot2 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger2#maxRotation"));
	self.tempCnt2 = 0;

	-- Temperaturzeiger3 / Wasser Temperatur Anzeige Rund
	self.temperaturZeiger3 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger3#zeigerIndex"));
	self.temperaturZeigerMaxRot3 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger3#maxRotation"));
	self.tempCnt3 = 0;
	
	-- Temperaturzeiger4 / Druckluft Anzeige Rund
	self.temperaturZeiger4 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger4#zeigerIndex"));
	self.temperaturZeigerMaxRot4 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.TractorAnimations.TemperaturZeiger4#maxRotation"));
	self.tempCnt4 = 0;

	-- Ladekontrollleuchte / Batterie load light
	self.ladeLeuchte = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TractorAnimations.LadeKontrollLeuchte#index"));
	setVisibility(self.ladeLeuchte, false);
	self.ladeLeuchteOn = 0;
	self.ladeTimer = 50;
end;

function TractorAnimations:delete()
end;

function TractorAnimations:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TractorAnimations:keyEvent(unicode, sym, modifier, isDown)
end;

function TractorAnimations:updateTick(dt)
end;

function TractorAnimations:update(dt)
	if self:getIsActive() then
		if self.isMotorStarted then
			-- Ladekontrollleuchte / Batterie load light
			if self.ladeLeuchteOn == 1 then
				setVisibility(self.ladeLeuchte, true);
				if self.movingDirection ~= 0 then
					self.timerTrue = true;
				end;
				if self.timerTrue then
					self.ladeTimer = math.max(self.ladeTimer - 0.1, 0);
				end;
				if self.ladeTimer == 0 then
					setVisibility(self.ladeLeuchte, false);
					self.timerTrue = nil;
					self.ladeLeuchteOn = 0;
					self.ladeTimer = 50;
				end;
			end;
	
			-- Zapfwellenstummel / Powershaft rotation
			rotate(self.stummelIndex, 0,0,0.001*dt);

		-- Temperaturanzeiger / temperature display animation und / and berechnung / calculation
			if self.tempCnt < 3000 then
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = self.tempCnt + 0.5;
			elseif self.tempCnt > 3000 and self.tempCnt < 6000 then
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.2, 10000);			
			else
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.05, 10000);
			end;
			
		-- Temperaturanzeiger2
			if self.tempCnt2 < 3000 then
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = self.tempCnt2 + 0.8;
			elseif self.tempCnt2 > 3000 and self.tempCnt2 < 6000 then
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = math.min(self.tempCnt2 + 0.3, 10000);			
			else
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = math.min(self.tempCnt2 + 0.04, 10000);
			end;
			
		-- Temperaturanzeiger3
			if self.tempCnt3 < 3000 then
				setRotation(self.temperaturZeiger3, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot3/10000)*self.tempCnt3), 0);
				self.tempCnt3 = self.tempCnt3 + 0.8;
			elseif self.tempCnt3 > 3000 and self.tempCnt3 < 6000 then
				setRotation(self.temperaturZeiger3, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot3/10000)*self.tempCnt3), 0);
				self.tempCnt3 = math.min(self.tempCnt3 + 0.3, 10000);			
			else
				setRotation(self.temperaturZeiger3, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot3/10000)*self.tempCnt3), 0);
				self.tempCnt3 = math.min(self.tempCnt3 + 0.04, 10000);
			end;
			
		-- Temperaturanzeiger4
			if self.tempCnt4 < 3000 then
				setRotation(self.temperaturZeiger4, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot4/10000)*self.tempCnt4), 0);
				self.tempCnt4 = self.tempCnt4 + 8;
			elseif self.tempCnt4 > 3000 and self.tempCnt4 < 6000 then
				setRotation(self.temperaturZeiger4, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot4/10000)*self.tempCnt4), 0);
				self.tempCnt4 = math.min(self.tempCnt4 + 8, 10000);			
			else
				setRotation(self.temperaturZeiger4, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot4/10000)*self.tempCnt4), 0);
				self.tempCnt4 = math.min(self.tempCnt4 + 8, 10000);
			end;
		end;
	else
		self.tempCnt = math.max(self.tempCnt - 0.08, 0);
		self.tempCnt2 = math.max(self.tempCnt2 - 0.1, 0);
		self.tempCnt3 = math.max(self.tempCnt3 - 0.1, 0);
		self.tempCnt4 = math.max(self.tempCnt4 - 2, 0);
	end;
end;

function TractorAnimations:draw()
end;

function TractorAnimations:onEnter()
	self.ladeLeuchteOn = 1;
end;

function TractorAnimations:onLeave()
	self.ladeLeuchteOn = 0;
end;